<?php

namespace Ems\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

use Ems\Services\EnderecoService;

class EnderecoController {
    /** @var EnderecoService */
    protected $enderecoService;

    public function __construct(
        EnderecoService $enderecoService
    ) {
        $this->enderecoService = $enderecoService;
    }

    public function pesquisarCep(
        Request\Row $request,
        Response $response
    ) {
        try {
            $row = $request->getRow();

            $cep = (string) $row['CEP'];

            $status = $this->enderecoService->
                pesquisarCep($cep);

            $response->addDataSet(new DataSet('pesquisarCep', $status));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}
