/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 0060_SDXSTPO_ATUALIZA_FORNECEDOR_SAC.sql

Descrio:
Atualiza as informaes dos fornecedores no "TecFood" de acordo com
as alteraes sobre o cadastro de fornecedor no sistema "SAC".

Criao:
22/04/2008 Raquel Cunha
*/

CREATE OR REPLACE  PROCEDURE ATUALIZA_FORNECEDOR_SAC 
  (P_CDFORNECED   IN VARCHAR2,
   P_IDTPIJURFORN IN VARCHAR2,
   P_NRINSJURFORN IN VARCHAR2,
   P_NMRAZSOCFORN IN VARCHAR2,
   P_NMFANTFORN   IN VARCHAR2,
   P_NRINSESTFORN IN VARCHAR2,
   P_IDSITUCADA   IN VARCHAR2 DEFAULT 'A',
   P_CDGRUPOFISC  IN VARCHAR2,
   P_IDFORNINTER  IN VARCHAR2 DEFAULT 'N',
   P_IDTPENDEFORN IN VARCHAR2,
   P_DSENDEFORN   IN VARCHAR2,
   P_NMBAIRFORN   IN VARCHAR2,
   P_CDPAIS       IN VARCHAR2,
   P_SGESTADO     IN VARCHAR2,
   P_NMMUNICIPIO  IN VARCHAR2,
   P_NRCEPFORN    IN VARCHAR2,
   P_IDFUNCAO     IN VARCHAR2) IS

   V_SGESTADO        VARCHAR2(2);
   V_CDMUNICIPIO     VARCHAR2(4);
   V_CDMUNICIPIOTEMP VARCHAR2(4);
   V_CDFORNECED      VARCHAR2(21);
   V_CDFORNECEND     VARCHAR2(21);
BEGIN
   IF P_SGESTADO IS NULL THEN
      SELECT MAX(SGESTADO)
      INTO V_SGESTADO
      FROM ESTADO
      WHERE CDPAIS = P_CDPAIS AND
            SGESTADO =  'ZZ';
      IF V_SGESTADO IS NULL THEN
         INSERT INTO ESTADO
            (CDPAIS, SGESTADO, NMESTADO)
         VALUES
            (P_CDPAIS, 'ZZ', 'TEMPORARIO');
         COMMIT;
         V_SGESTADO := 'ZZ';
      END IF;
   ELSE
      V_SGESTADO := P_SGESTADO;
   END IF;

   IF P_NMMUNICIPIO IS NOT NULL THEN
      SELECT MAX(CDMUNICIPIO)
      INTO V_CDMUNICIPIO
      FROM MUNICIPIO
      WHERE (CDPAIS   = P_CDPAIS)   AND
            (SGESTADO = V_SGESTADO) AND
            (UPPER(NMMUNICIPIO) LIKE P_NMMUNICIPIO);

      IF V_CDMUNICIPIO IS NULL THEN
         SELECT MAX(CDMUNICIPIO)
         INTO V_CDMUNICIPIOTEMP
         FROM MUNICIPIO
         WHERE (CDPAIS   = P_CDPAIS)   AND
               (SGESTADO = V_SGESTADO) AND
               (CDMUNICIPIO = '9999');
         IF V_CDMUNICIPIOTEMP IS NULL THEN
            INSERT INTO MUNICIPIO
               (CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO)
            VALUES
               (P_CDPAIS, V_SGESTADO, '9999', 'TEMPORARIO');
            COMMIT;
            V_CDMUNICIPIO := '9999';
         ELSE
            V_CDMUNICIPIO := V_CDMUNICIPIOTEMP;
         END IF;
      END IF;
   ELSE
      SELECT MAX(CDMUNICIPIO)
      INTO V_CDMUNICIPIOTEMP
      FROM MUNICIPIO
      WHERE (CDPAIS   = P_CDPAIS)   AND
            (SGESTADO = V_SGESTADO) AND
            (CDMUNICIPIO = '9999');
      IF V_CDMUNICIPIOTEMP IS NULL THEN
         INSERT INTO MUNICIPIO
            (CDPAIS, SGESTADO, CDMUNICIPIO, NMMUNICIPIO)
         VALUES
            (P_CDPAIS, V_SGESTADO, '9999', 'TEMPORARIO');
         COMMIT;
         V_CDMUNICIPIO := '9999';
      ELSE
         V_CDMUNICIPIO := V_CDMUNICIPIOTEMP;
      END IF;
   END IF;

   IF P_IDFUNCAO = 'I' THEN
      SELECT MAX(CDFORNECED)
      INTO V_CDFORNECED
      FROM FORNECEDOR
      WHERE (CDFORNECED = P_CDFORNECED);

      IF V_CDFORNECED IS NULL THEN
         INSERT INTO FORNECEDOR
            (CDFORNECED, IDTPIJURFORN, NRINSJURFORN, NMRAZSOCFORN,
             NMFANTFORN, NRINSESTFORN, IDSITUCADA, IDFORNINTER, CDGRUPOFISC)
         VALUES
            (P_CDFORNECED, P_IDTPIJURFORN, P_NRINSJURFORN, P_NMRAZSOCFORN,
             P_NMFANTFORN, P_NRINSESTFORN, P_IDSITUCADA, P_IDFORNINTER, P_CDGRUPOFISC);
         COMMIT;
      END IF;

      SELECT MAX(CDFORNECED)
      INTO V_CDFORNECEND
      FROM ENDEFORN
      WHERE (CDFORNECED   = P_CDFORNECED) AND
            (IDTPENDEFORN = P_IDTPENDEFORN);

      IF V_CDFORNECEND IS NULL THEN
         INSERT INTO ENDEFORN
             (CDFORNECED, IDTPENDEFORN, DSENDEFORN, NMBAIRFORN,
              CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFORN)
         VALUES
             (P_CDFORNECED, P_IDTPENDEFORN, P_DSENDEFORN, P_NMBAIRFORN,
              P_CDPAIS, V_SGESTADO, V_CDMUNICIPIO, P_NRCEPFORN);
         COMMIT;
      END IF;
   END IF;

   IF P_IDFUNCAO = 'A' THEN
      SELECT MAX(CDFORNECED)
      INTO V_CDFORNECED
      FROM FORNECEDOR
      WHERE (CDFORNECED = P_CDFORNECED);

      IF V_CDFORNECED IS NOT NULL THEN
         UPDATE FORNECEDOR
         SET IDTPIJURFORN = P_IDTPIJURFORN,
             NRINSJURFORN = P_NRINSJURFORN,
             IDFORNINTER  = P_IDFORNINTER,
             NMRAZSOCFORN = P_NMRAZSOCFORN,
             NMFANTFORN   = P_NMFANTFORN,
             NRINSESTFORN = P_NRINSESTFORN,
             IDSITUCADA   = P_IDSITUCADA,
             CDCSTDIG1ENT = '0',
             CDGRUPOFISC  = P_CDGRUPOFISC
         WHERE CDFORNECED = P_CDFORNECED;
         COMMIT;
      END IF;

      SELECT MAX(CDFORNECED)
      INTO V_CDFORNECEND
      FROM ENDEFORN
      WHERE (CDFORNECED   = P_CDFORNECED) AND
            (IDTPENDEFORN = P_IDTPENDEFORN);

      IF V_CDFORNECEND IS NOT NULL THEN
         UPDATE ENDEFORN
         SET CDPAIS      = P_CDPAIS,
             SGESTADO    = V_SGESTADO,
             CDMUNICIPIO = V_CDMUNICIPIO,
             DSENDEFORN  = P_DSENDEFORN,
             NMBAIRFORN  = P_NMBAIRFORN,
             NRCEPFORN   = P_NRCEPFORN
         WHERE
            CDFORNECED   = P_CDFORNECED AND
            IDTPENDEFORN = P_IDTPENDEFORN;
         COMMIT;
      END IF;
   END IF;

   IF P_IDFUNCAO = 'E' THEN

      SELECT MAX(CDFORNECED)
      INTO V_CDFORNECEND
      FROM ENDEFORN
      WHERE (CDFORNECED   = P_CDFORNECED);

      IF V_CDFORNECEND IS NOT NULL THEN
         DELETE FROM ENDEFORN
         WHERE
            CDFORNECED   = P_CDFORNECED;
         COMMIT;
      END IF;

      SELECT MAX(CDFORNECED)
      INTO V_CDFORNECED
      FROM FORNECEDOR
      WHERE (CDFORNECED = P_CDFORNECED);

      IF V_CDFORNECED IS NOT NULL THEN
         DELETE FROM FORNECEDOR
         WHERE CDFORNECED = P_CDFORNECED;
         COMMIT;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_FORNECEDOR_SAC','5.45.XXX'); END;
/

